package de.intevation.flys.client.client.ui;

import com.google.gwt.core.client.GWT;
import com.google.gwt.resources.client.ImageResource;

import com.smartgwt.client.types.VerticalAlignment;
import com.smartgwt.client.widgets.Canvas;
import com.smartgwt.client.widgets.Img;
import com.smartgwt.client.widgets.layout.HLayout;

import de.intevation.flys.client.shared.model.DataList;
import de.intevation.flys.client.client.FLYSConstants;
import de.intevation.flys.client.shared.model.Data;


/**
 * This UIProvider displays the DataItems contained in the Data object in a
 * combo box as SelectProvider does. Furthermore, there is a map displayed that
 * lets the user choose a river by selecting it on the map.
 *
 * @author <a href="mailto:ingo.weinzierl@intevation.de">Ingo Weinzierl</a>
 */
public class MapSelection extends SelectProvider {

    /** The interface that provides the image resources. */
    private FLYSConstants MESSAGES = GWT.create(FLYSConstants.class);

    protected ModuleSelection moduleSelection;

    public MapSelection() {
    }


    /**
     * This method currently returns a
     * {@link com.smartgwt.client.widgets.form.DynamicForm} that contains all
     * data items in a combobox stored in <i>data</i>.<br>
     *
     * <b>TODO: The map panel for the river selection needs to be
     * implemented!</b>
     *
     * @param data The {@link DataList} object.
     *
     * @return a combobox.
     */
    protected Canvas createWidget(DataList data) {
        GWT.log("MapSelection - create()");

        String baseUrl = GWT.getHostPageBaseURL();

        HLayout h = new HLayout();
        h.setAlign(VerticalAlignment.TOP);
        h.setHeight(100);
        moduleSelection = new ModuleSelection();

        Canvas form  = moduleSelection.create(data);
        form.setWidth(250);
        form.setLayoutAlign(VerticalAlignment.TOP);

        Img map = new Img(baseUrl + MESSAGES.riverMap(), 400, 452);

        // TODO implement event handling in the river map

        h.addMember(form);
        helperContainer.addMember(map);

        return h;
    }

    protected Data[] getData() {
        if (moduleSelection != null) {
            return moduleSelection.getData();
        }
        else {
            return null;
        }
    }
}
// vim:set ts=4 sw=4 si et sta sts=4 fenc=utf8 :
